<template>
  <div class="row q-pa-xl">
    <div class="col flex justify-center">
      <q-card flat class="q-pa-lg rounded-borders-10 card-container">
        <q-card-section>
          <div class="row">
            <div class="col flex justify-center">
              <div class="image-avatar">
                <q-avatar
                  :color="userForm.profile_picture ? 'white' : 'positive'"
                  class="logo-container rounded-borders-10"
                >
                  <img
                    :src="userForm.profile_picture"
                    v-if="userForm.profile_picture"
                  />

                  <span v-else class="title-headline text-white">
                    {{ userForm.company_name.slice(0, 1) }}
                  </span>
                </q-avatar>

                <div class="image-btn">
                  <q-btn
                    class="btn--shade-1 btn-edit text-white q-pa-sm q-ma-xs"
                    icon="eva-plus-outline"
                    style="border: 5px solid #fff; border-radius: 50px"
                    @click="showUploadProfileDialog = true"
                  />
                </div>
              </div>
            </div>

            <div class="col-10 q-ml-md q-my-auto">
              <p class="title-headline q-mb-sm">
                {{ userForm.company_name }}
              </p>
              <p class="title-6">ID #{{ userForm.id }}</p>
            </div>

            <q-spacer />

            <div class="col" align="right">
              <q-btn
                unelevated
                size="md"
                icon="eva-edit-outline"
                class="btn-edit text-grey-7"
                @click="
                  showEmployerInfo(
                    userForm,
                    addressStore.address,
                    industryStore.industries,
                    requirementStore.requirement
                  ),
                    (showEditDialog = true)
                "
              />
            </div>
          </div>
        </q-card-section>

        <q-card-section>
          <div class="row">
            <div class="col">
              <div class="row">
                <div class="col q-gutter-md">
                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        INDUSTRY
                      </p>
                    </div>

                    <div class="col-7">
                      <p
                        v-for="(item, key) in industryStore.industries"
                        :key="key"
                        class="title-8"
                      >
                        {{ item.industry.name }}
                      </p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        INCORPORATION DATE
                      </p>
                    </div>

                    <div class="col-7">
                      <p class="title-8">
                        {{ formatDate(userForm.company_incorporation_date) }}
                      </p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        FIRST NAME
                      </p>
                    </div>

                    <div class="col-7">
                      <p class="title-8">{{ userForm.first_name }}</p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        LAST NAME
                      </p>
                    </div>

                    <div class="col-7">
                      <p class="title-8">{{ userForm.last_name }}</p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        MOBILE NUMBER
                      </p>
                    </div>

                    <div class="col-7">
                      <p class="title-8">{{ userForm.mobile_number }}</p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        EMAIL ADDRESS
                      </p>
                    </div>

                    <div class="col-7">
                      <p class="title-8">{{ userForm.email }}</p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        ADDRESS (STREET)
                      </p>
                    </div>

                    <div class="col-7">
                      <p class="title-8">{{ addressStore.address.street }}</p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        ADDRESS (BRGY)
                      </p>
                    </div>

                    <div class="col-7">
                      <p
                        v-for="(
                          barangay, key
                        ) in referenceStore.barangays.filter(
                          (item) => item.id === addressStore.address.barangay_id
                        )"
                        :key="key"
                        class="title-8"
                      >
                        {{ barangay.name }}
                      </p>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col q-my-auto">
                      <p class="text-caption text-weight-bold text-grey-7">
                        ADDRESS (CITY)
                      </p>
                    </div>

                    <div class="col-7">
                      <p
                        v-for="(city, key) in referenceStore.cities.filter(
                          (item) => item.id === addressStore.address.city_id
                        )"
                        :key="key"
                        class="title-8"
                      >
                        {{ city.name }}
                      </p>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <div class="col">
              <p class="text-caption text-weight-bold text-grey-7">
                REQUIREMENTS
              </p>
              <div class="row">
                <div class="col">
                  <ul>
                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          Company Profile
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement.company_profile_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          Business Permit for Current Year
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement.business_permit_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          DTI/SEC Registration
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement
                                  .dti_or_sec_registration_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          BIR Registration
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement
                                  .bir_registration_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          Job Order/Advertisement
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement
                                  .job_order_or_job_advertisement_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          POEA License (Overseas)
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement.poea_license_url
                              )
                            "
                            :disable="FILE_POEA === null"
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row q-mb-md">
                        <div class="col title-8 flex items-center">
                          Letter Of Intent
                        </div>
                        <div class="col-4" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement
                                  .letter_of_intent_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>

                    <li>
                      <div class="row">
                        <div class="col title-8 flex items-center">
                          Notarized affidavit of undertaking stating the ff:

                          <div class="q-my-sm">
                            A. Intent of the Special Recruitment Activity
                          </div>
                          <div class="q-mb-sm">B. Number of vacancies</div>
                          <div class="q-mb-sm">C. Vacant positions</div>
                          <div class="q-mb-sm">
                            D. Specify gender of applicants solicited
                          </div>
                          <div class="q-mb-sm">
                            E. The names of staff conducting recruitment
                          </div>
                          <div class="q-mb-sm">
                            F. Stating that the recruitment is not for manpower
                            pooling
                          </div>
                          <div class="q-mb-sm">
                            G. Stating that no fees shall be collected for the
                            conduct of the recruitment
                          </div>
                          <div class="q-mb-sm">
                            H. Stating that a terminal report will be submitted
                            within 120 days
                          </div>
                        </div>
                        <div class="col-4 q-my-auto" align="right">
                          <q-btn
                            unelevated
                            class="btn-lg bg-positive text-white"
                            label="VIEW"
                            @click="
                              openFile(
                                requirementStore.requirement
                                  .notarized_affidavit_url
                              )
                            "
                          />
                        </div>
                      </div>
                    </li>
                  </ul>
                </div>
              </div>
            </div>
          </div>
        </q-card-section>
      </q-card>
    </div>
  </div>

  <!-- DIALOG: EDIT PROFILE -->
  <q-dialog
    v-model="showEditDialog"
    persistent
    @hide="showEditDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Edit Profile</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="editDetails(form, REQUIREMENT_ID)">
          <p class="text-positive title-5 q-mt-xl">Basic Information</p>
          <div class="row q-ml-md">
            <div class="col q-mr-lg">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >FIRST NAME <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.first_name"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>

            <div class="col q-mr-lg">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >MIDDLE NAME</label
                >
                <q-input
                  v-model="form.middle_name"
                  dense
                  outlined
                  class="q-mt-sm"
                />
              </div>
            </div>

            <div class="col">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >LAST NAME <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.last_name"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>
          </div>

          <div class="row q-ml-md">
            <div class="col q-mr-lg">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >COMPANY NAME <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.company_name"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>

            <div class="col q-mr-lg">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >INCORPORATION DATE
                  <span class="text-negative">*</span></label
                >
                <q-input
                  dense
                  outlined
                  v-model="form.company_incorporation_date"
                  class="q-mt-sm"
                  mask="date"
                  :rules="[validations.requiredField]"
                >
                  <template v-slot:append>
                    <q-icon name="eva-calendar-outline" class="cursor-pointer">
                      <q-popup-proxy
                        cover
                        transition-show="scale"
                        transition-hide="scale"
                      >
                        <q-date v-model="form.company_incorporation_date">
                          <div class="row items-center justify-end">
                            <q-btn
                              v-close-popup
                              label="Close"
                              color="primary"
                              flat
                            />
                          </div>
                        </q-date>
                      </q-popup-proxy>
                    </q-icon>
                  </template>
                </q-input>
              </div>
            </div>

            <div class="col">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >MOBILE NUMBER <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.mobile_number"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                  v-on:keyup="formatMobileNumber(form.mobile_number)"
                  placeholder="xxx-xxx-xxxx"
                  maxlength="12"
                >
                  <template v-slot:prepend>
                    <span class="title-7">(+63)</span>
                  </template>
                </q-input>
              </div>
            </div>
          </div>

          <div class="row q-ml-md">
            <div class="col q-mr-lg">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >STREET <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.street"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>

            <div class="col q-mr-lg">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >ADDRESS (CITY) <span class="text-negative">*</span></label
                >
                <q-select
                  v-model="form.city_id"
                  :options="cityOptions"
                  use-input
                  hide-selected
                  fill-input
                  input-debounce="0"
                  option-label="name"
                  option-value="id"
                  map-options
                  emit-value
                  dense
                  outlined
                  class="q-mt-sm"
                  @filter="filterCityOptions"
                  :rules="[validations.requiredField]"
                >
                  <template v-slot:no-option>
                    <q-item>
                      <q-item-section class="text-grey-7">
                        No results
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
              </div>
            </div>

            <div class="col">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >ADDRESS (BARANGAY)
                  <span class="text-negative">*</span>
                </label>
                <q-select
                  v-model="form.barangay_id"
                  :options="barangayOptions"
                  use-input
                  hide-selected
                  fill-input
                  input-debounce="0"
                  option-label="name"
                  option-value="id"
                  map-options
                  emit-value
                  dense
                  outlined
                  class="q-mt-sm"
                  @filter="filterBarangayOptions"
                  :rules="[validations.requiredField]"
                >
                  <template v-slot:no-option>
                    <q-item>
                      <q-item-section class="text-grey-7">
                        No results
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
              </div>
            </div>
          </div>

          <!-- <div class="row q-ml-md">
            <div class="col"></div>
            <div class="col-5">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-7"
                  >INDUSTRY</label
                >
                <q-select
                  v-model="form.industry_id"
                  :options="referenceStore.industries"
                  option-label="name"
                  option-value="id"
                  map-options
                  emit-value
                  dense
                  outlined
                  class="q-mt-sm"
                  :disable="form.industry_id"
                />
              </div>
            </div>

            <div class="col">
              <div class="q-ml-sm q-py-lg q-mt-xs" v-if="form.industry_id">
                <q-btn
                  unelevated
                  size="lg"
                  icon="eva-delete-outline"
                  class="btn-edit text-grey-7"
                  @click="
                    showDeleteWork(form.industry_id), (showDeleteDialog = true)
                  "
                />
              </div>
            </div>
          </div> -->

          <div>
            <p class="text-positive title-5 q-mt-xl">PESO Requirements</p>
            <div class="row q-ml-md">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >COMPANY PROFILE <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined
                    ref="fileInput"
                    v-model="requirementsForm.company_profile"
                    :label="
                      requirementsForm.company_profile === null
                        ? requirementsForm.company_profile_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="onRejected(requirementsForm.company_profile)"
                    @update:model-value="
                      onRejected(requirementsForm.company_profile)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >BUSINESS PERMIT FOR CURRENT YEAR
                    <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="requirementsForm.business_permit"
                    :label="
                      requirementsForm.business_permit === null
                        ? requirementsForm.business_permit_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="onRejected(requirementsForm.business_permit)"
                    @update:model-value="
                      onRejected(requirementsForm.business_permit)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >DTI/SEC REGISTRATION
                    <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="requirementsForm.dti_or_sec_registration"
                    :label="
                      requirementsForm.dti_or_sec_registration === null
                        ? requirementsForm.dti_or_sec_registration_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="
                      onRejected(requirementsForm.dti_or_sec_registration)
                    "
                    @update:model-value="
                      onRejected(requirementsForm.dti_or_sec_registration)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>
            </div>

            <div class="row q-ml-md">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >BIR REGISTRATION
                    <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined=""
                    v-model="requirementsForm.bir_registration"
                    :label="
                      requirementsForm.bir_registration === null
                        ? requirementsForm.bir_registration_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="onRejected(requirementsForm.bir_registration)"
                    @update:model-value="
                      onRejected(requirementsForm.bir_registration)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >JOB ORDER (OVERSEAS) / JOB ADVERTISEMENT (LOCAL)
                    <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="requirementsForm.job_order_or_job_advertisement"
                    :label="
                      requirementsForm.job_order_or_job_advertisement === null
                        ? requirementsForm.job_order_or_job_advertisement_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="
                      onRejected(
                        requirementsForm.job_order_or_job_advertisement
                      )
                    "
                    @update:model-value="
                      onRejected(
                        requirementsForm.job_order_or_job_advertisement
                      )
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >POEA LICENSE (OVERSEAS)</label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="requirementsForm.poea_license"
                    :label="
                      requirementsForm.poea_license === null
                        ? requirementsForm.poea_license_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="onRejected(requirementsForm.poea_license)"
                    @update:model-value="
                      onRejected(requirementsForm.poea_license)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>
            </div>

            <div class="row q-ml-md">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >LETTER OF INTENT
                    <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="requirementsForm.letter_of_intent"
                    :label="
                      requirementsForm.letter_of_intent === null
                        ? requirementsForm.letter_of_intent_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="onRejected(requirementsForm.letter_of_intent)"
                    @update:model-value="
                      onRejected(requirementsForm.letter_of_intent)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-7"
                    >NOTARIZED AFFIDAVIT OF UNDERTAKING
                    <span class="text-negative">*</span></label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="requirementsForm.notarized_affidavit"
                    :label="
                      requirementsForm.notarized_affidavit === null
                        ? requirementsForm.notarized_affidavit_name
                        : 'Selected File'
                    "
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    @rejected="onRejected(requirementsForm.notarized_affidavit)"
                    @update:model-value="
                      onRejected(requirementsForm.notarized_affidavit)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>

                  <p id="error" class="q-field_messages text-negative">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col"></div>
            </div>

            <div class="row flex items-center">
              <div class="col q-mr-lg"></div>

              <div
                class="col text-grey-7 q-mx-xs q-mt-xs"
                style="font-size: 12px"
              >
                <p class="text-negative text-weight-bold">
                  (IMPORTANT) Notarized Affidavit should state the ff:
                </p>
                <div class="row q-gutter-md">
                  <div class="col text-weight-bold">
                    <ol type="A" style="padding-left: 15px; margin-top: -5px">
                      <li>Intent of the Special Recruitment Activity</li>
                      <li>Number of vacancies</li>
                      <li>Vacant positions</li>
                      <li>Specify gender of applicants solicited</li>
                      <li>The names of staff conducting recruitment</li>
                      <li>
                        Stating that the recruitment is not for manpower pooling
                      </li>
                      <li>
                        Stating that no fees shall be collected for the conduct
                        of the recruitment
                      </li>
                      <li>
                        Stating that a terminal report will be submitted within
                        120 days
                      </li>
                    </ol>
                  </div>
                </div>
              </div>

              <div class="col"></div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg text-white"
              color="green-10"
              label="SUBMIT"
              type="submit"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: UPLOAD PROFILE PICTURE -->
  <q-dialog
    v-model="showUploadProfileDialog"
    persistent
    @hide="showUploadProfileDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Upload Profile Photo</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <div>
          <q-file
            outlined
            v-model="form.profile_picture"
            max-file-size="5242880"
            :rules="[validations.requiredField]"
            :filter="checkFileTypeProfile"
            @rejected="onRejected(form.profile_picture)"
          >
            <template v-slot:prepend>
              <q-icon name="eva-attach-outline" />
            </template>
          </q-file>
          <p id="error" class="q-field_messages text-negative q-pa-sm">
            {{ errorMessage }}
          </p>
        </div>
      </q-card-section>

      <div class="q-my-md" align="center">
        <q-btn
          unelevated
          label="UPLOAD"
          class="btn--shade-1 btn-lg text-white q-mr-sm"
          :loading="loading"
          @click="confirmUploadProfile(form)"
        />
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, ref, reactive } from "vue";
import { requiredField } from "src/hooks/validations";
import { useAddress } from "../../store/address";
import { useIndustry } from "../../store/industry";
import { useRequirement } from "../../store/requirement";
import { useUser } from "src/layouts/portals/store/user";
// import { useReference } from "../../store/reference";
import { useReference } from "src/modules/auth/store/reference";
import useEmployerHook from "../../hooks/employerHook";
import dayjs from "dayjs";

export default defineComponent({
  setup() {
    const addressStore = useAddress();
    const { showAddress } = addressStore;

    const industryStore = useIndustry();
    const { getEmployerIndustries } = industryStore;

    const requirementStore = useRequirement();
    const { getEmployerRequirements, showEmployerRequirement } =
      requirementStore;

    const userStore = useUser();
    const { getEmployerInfo } = userStore;

    const referenceStore = useReference();
    const { getCities, getBarangays, getIndustries } = referenceStore;

    const {
      loading,
      deleteLoading,
      doUpdateBasicInfo,
      doUpdateAddress,
      doUpdatePhoto,
      doUpdateRequirements,
    } = useEmployerHook();

    const USER_ID = ref(null);
    const ADDRESS_ID = ref(null);
    const REQUIREMENT_ID = ref(null);
    const FILE_POEA = ref(null);
    const showEditDialog = ref(false);
    const showUploadProfileDialog = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");
    const cityOptions = ref(referenceStore.cities);
    const barangayOptions = ref(referenceStore.barangays);
    const fileNameVisible = ref(true);

    const form = reactive({
      id: null,
      company_name: "",
      first_name: "",
      middle_name: "",
      last_name: "",
      company_incorporation_date: "",
      mobile_number: "",
      street: null,
      city_id: "",
      barangay_id: "",
      industry_id: null,
      requirement_id: null,
      profile_picture: null,
      _method: "PUT",
    });

    const userForm = reactive({
      id: null,
      company_name: "",
      first_name: "",
      middle_name: "",
      last_name: "",
      company_incorporation_date: "",
      mobile_number: "",
      email: null,
      profile_picture: null,
    });

    const requirementsForm = reactive({
      id: null,
      company_profile: null,
      company_profile_name: "",
      business_permit: null,
      business_permit_name: "",
      dti_or_sec_registration: null,
      dti_or_sec_registration_name: "",
      bir_registration: null,
      bir_registration_name: "",
      job_order_or_job_advertisement: null,
      job_order_or_job_advertisement_name: "",
      poea_license: null,
      poea_license_name: "",
      letter_of_intent: null,
      letter_of_intent_name: "",
      notarized_affidavit: null,
      notarized_affidavit_name: "",
    });

    const fetchUserDetails = async () => {
      USER_ID.value = LocalStorage.getItem("auth").id;
      ADDRESS_ID.value = LocalStorage.getItem("auth").address.id;

      if (USER_ID.value) {
        await getEmployerInfo(USER_ID.value);

        userForm.id = userStore.userDetails.id;
        userForm.company_name = userStore.userDetails.company_name;
        userForm.first_name = userStore.userDetails.first_name;
        userForm.middle_name = userStore.userDetails.middle_name;
        userForm.last_name = userStore.userDetails.last_name;
        userForm.company_incorporation_date =
          userStore.userDetails.company_incorporation_date;
        userForm.mobile_number = userStore.userDetails.mobile_number;
        userForm.email = userStore.userDetails.email;
        userForm.profile_picture = userStore.userDetails.profile_picture_url;
      }
      await getEmployerIndustries();
      await getEmployerRequirements();
      for (let x = 0; x < requirementStore.requirements.length; x++) {
        const attachments = requirementStore.requirements[x];

        if (attachments.user_id === USER_ID.value) {
          REQUIREMENT_ID.value = attachments.id;
        }
      }
      await showEmployerRequirement(REQUIREMENT_ID.value);
      FILE_POEA.value = requirementStore.requirement.poea_license;
      await showAddress(ADDRESS_ID.value);
      await getCities();
      await getBarangays();
      await getIndustries();
    };

    const openFile = (url) => {
      window.open(url);
    };

    const formatDate = (date) => {
      return dayjs(date).format("MM/DD/YY");
    };

    const showEmployerInfo = (info, address, industry, requirement) => {
      showEmployerRequirement(REQUIREMENT_ID.value);
      showAddress(ADDRESS_ID.value);

      form.id = info.id;
      form.company_name = info.company_name;
      form.first_name = info.first_name;
      form.middle_name = info.middle_name;
      form.last_name = info.last_name;
      form.company_incorporation_date = info.company_incorporation_date;
      form.mobile_number = info.mobile_number;
      form.street = address.street;
      form.barangay_id = address.barangay_id;
      form.city_id = address.city_id;
      form.requirement_id = requirement.id;

      requirementsForm.company_profile_name = requirement.company_profile;
      requirementsForm.business_permit_name = requirement.business_permit;
      requirementsForm.dti_or_sec_registration_name =
        requirement.dti_or_sec_registration;
      requirementsForm.bir_registration_name = requirement.bir_registration;
      requirementsForm.job_order_or_job_advertisement_name =
        requirement.job_order_or_job_advertisement;
      requirementsForm.poea_license_name = requirement.poea_license;
      requirementsForm.letter_of_intent_name = requirement.letter_of_intent;
      requirementsForm.notarized_affidavit_name =
        requirement.notarized_affidavit;
    };

    const formatMobileNumber = (number) => {
      let formattedNumber = number
        .replace(/\D+/g, "")
        .replace(/(\d{3})(\d{3})(\d{3})/, "$1-$2-$3");
      form.mobile_number = formattedNumber;
    };

    const toggleFileNameVisibility = () => {
      fileNameVisible.value = !fileNameVisible.value;
    };

    const onFileChange = (newFile) => {
      if (requirementsForm.company_profile) {
        requirementsForm.company_profile = newFile;
      }

      if (requirementsForm.business_permit) {
        requirementsForm.business_permit = newFile;
      }

      if (requirementsForm.dti_or_sec_registration) {
        requirementsForm.dti_or_sec_registration = newFile;
      }

      if (requirementsForm.bir_registration) {
        requirementsForm.bir_registration = newFile;
      }

      if (requirementsForm.job_order_or_job_advertisement) {
        requirementsForm.job_order_or_job_advertisement = newFile;
      }

      if (requirementsForm.poea_license) {
        requirementsForm.poea_license = newFile;
      }

      if (requirementsForm.notarized_affidavit) {
        requirementsForm.notarized_affidavit = newFile;
      }
    };

    const editDetails = async (form, requirementId) => {
      loading.value = true;
      USER_ID.value = LocalStorage.getItem("auth").id;
      ADDRESS_ID.value = LocalStorage.getItem("auth").address.id;

      const formData = new FormData();

      if (
        requirementsForm.company_profile === null &&
        requirementsForm.business_permit === null &&
        requirementsForm.dti_or_sec_registration === null &&
        requirementsForm.bir_registration === null &&
        requirementsForm.job_order_or_job_advertisement === null &&
        requirementsForm.poea_license === null &&
        requirementsForm.notarized_affidavit === null
      ) {
        await doUpdateBasicInfo(USER_ID.value, form);
        await doUpdateAddress(ADDRESS_ID.value, form);
      } else {
        formData.append("company_name", form.company_name);
        formData.append("first_name", form.first_name);
        formData.append("middle_name", form.middle_name);
        formData.append("last_name", form.last_name);
        formData.append(
          "company_incorporation_date",
          form.company_incorporation_date
        );
        formData.append("mobile_number", form.mobile_number);
        formData.append("street", form.street);
        formData.append("city_id", form.city_id);
        formData.append("barangay_id", form.barangay_id);

        if (requirementsForm.company_profile) {
          formData.append("company_profile", requirementsForm.company_profile);
        }

        if (requirementsForm.business_permit) {
          formData.append("business_permit", requirementsForm.business_permit);
        }

        if (requirementsForm.dti_or_sec_registration) {
          formData.append(
            "dti_or_sec_registration",
            requirementsForm.dti_or_sec_registration
          );
        }

        if (requirementsForm.bir_registration) {
          formData.append(
            "bir_registration",
            requirementsForm.bir_registration
          );
        }

        if (requirementsForm.job_order_or_job_advertisement) {
          formData.append(
            "job_order_or_job_advertisement",
            requirementsForm.job_order_or_job_advertisement
          );
        }

        if (requirementsForm.poea_license) {
          formData.append("poea_license", requirementsForm.poea_license);
        }

        if (requirementsForm.notarized_affidavit) {
          formData.append(
            "notarized_affidavit",
            requirementsForm.notarized_affidavit
          );
        }
        formData.append("_method", form._method);

        await doUpdateBasicInfo(USER_ID.value, form);
        await doUpdateAddress(ADDRESS_ID.value, form);
        await doUpdateRequirements(requirementId, formData);
      }

      loading.value = false;
      showEditDialog.value = false;
      fetchUserDetails();
    };

    const confirmUploadProfile = async (form) => {
      USER_ID.value = LocalStorage.getItem("auth").id;
      const formData = new FormData();
      formData.append(
        "profile_picture",
        form.profile_picture,
        form.profile_picture.name
      );
      formData.append("_method", form._method);

      await doUpdatePhoto(USER_ID.value, formData);
      showUploadProfileDialog.value = false;
      fetchUserDetails();
    };

    fetchUserDetails();

    return {
      addressStore,
      industryStore,
      requirementStore,
      userStore,
      referenceStore,
      form,
      userForm,
      requirementsForm,
      USER_ID,
      ADDRESS_ID,
      REQUIREMENT_ID,
      FILE_POEA,
      showEditDialog,
      errorMessage,
      loading,
      deleteLoading,
      showUploadProfileDialog,
      cityOptions,
      barangayOptions,
      checkFileType(files) {
        return files.filter(
          (file) =>
            file.type === "application/msword" ||
            file.type ===
              "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
            file.type === "application/pdf" ||
            file.type === "image/png" ||
            file.type === "image/jpeg" ||
            file.type === "image/jpg"
        );
      },
      onRejected(files) {
        for (let x = 0; x < files.length; x++) {
          const file = files[x];

          if (file.failedPropValidation === "max-file-size") {
            isError.value = true;
            errorMessage.value = "File size should not be greater than 5MB";
          } else if (file.failedPropValidation === "filter") {
            isError.value = true;
            errorMessage.value = "The file type uploaded is not supported";
          } else {
            isError.value = false;
            errorMessage.value = "";
          }
        }
      },
      validations: {
        requiredField,
      },
      openFile,
      showEmployerInfo,
      formatMobileNumber,
      editDetails,
      confirmUploadProfile,
      formatDate,
      toggleFileNameVisibility,
      onFileChange,
      filterCityOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          cityOptions.value = referenceStore.cities.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
      filterBarangayOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          barangayOptions.value = referenceStore.barangays.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
    };
  },
});
</script>

<style lang="scss" scoped>
.logo-container {
  width: 60px;
  height: 60px;
}
.card-container {
  width: 70%;
}
.image-avatar {
  margin: auto;
  position: relative;
}
.image-btn {
  width: 35px;
  height: 35px;
  position: absolute;
  right: -3.5px;
  bottom: -4px;
}
</style>
